# coding: utf-8

"""
    MailSlurp API

    MailSlurp is an API for sending and receiving emails from dynamically allocated email addresses. It's designed for developers and QA teams to test applications, process inbound emails, send templated notifications, attachments, and more.  ## Resources  - [Homepage](https://www.mailslurp.com) - Get an [API KEY](https://app.mailslurp.com/sign-up/) - Generated [SDK Clients](https://docs.mailslurp.com/) - [Examples](https://github.com/mailslurp/examples) repository  # noqa: E501

    The version of the OpenAPI document: 6.5.2
    Contact: contact@mailslurp.dev
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from mailslurp_client.configuration import Configuration


class CreateConnectorSmtpConnectionOptions(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'enabled': 'bool',
        'smtp_host': 'str',
        'smtp_port': 'int',
        'smtp_ssl': 'bool',
        'smtp_username': 'str',
        'smtp_password': 'str'
    }

    attribute_map = {
        'enabled': 'enabled',
        'smtp_host': 'smtpHost',
        'smtp_port': 'smtpPort',
        'smtp_ssl': 'smtpSsl',
        'smtp_username': 'smtpUsername',
        'smtp_password': 'smtpPassword'
    }

    def __init__(self, enabled=None, smtp_host=None, smtp_port=None, smtp_ssl=None, smtp_username=None, smtp_password=None, local_vars_configuration=None):  # noqa: E501
        """CreateConnectorSmtpConnectionOptions - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._enabled = None
        self._smtp_host = None
        self._smtp_port = None
        self._smtp_ssl = None
        self._smtp_username = None
        self._smtp_password = None
        self.discriminator = None

        if enabled is not None:
            self.enabled = enabled
        self.smtp_host = smtp_host
        if smtp_port is not None:
            self.smtp_port = smtp_port
        if smtp_ssl is not None:
            self.smtp_ssl = smtp_ssl
        if smtp_username is not None:
            self.smtp_username = smtp_username
        if smtp_password is not None:
            self.smtp_password = smtp_password

    @property
    def enabled(self):
        """Gets the enabled of this CreateConnectorSmtpConnectionOptions.  # noqa: E501


        :return: The enabled of this CreateConnectorSmtpConnectionOptions.  # noqa: E501
        :rtype: bool
        """
        return self._enabled

    @enabled.setter
    def enabled(self, enabled):
        """Sets the enabled of this CreateConnectorSmtpConnectionOptions.


        :param enabled: The enabled of this CreateConnectorSmtpConnectionOptions.  # noqa: E501
        :type: bool
        """

        self._enabled = enabled

    @property
    def smtp_host(self):
        """Gets the smtp_host of this CreateConnectorSmtpConnectionOptions.  # noqa: E501


        :return: The smtp_host of this CreateConnectorSmtpConnectionOptions.  # noqa: E501
        :rtype: str
        """
        return self._smtp_host

    @smtp_host.setter
    def smtp_host(self, smtp_host):
        """Sets the smtp_host of this CreateConnectorSmtpConnectionOptions.


        :param smtp_host: The smtp_host of this CreateConnectorSmtpConnectionOptions.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and smtp_host is None:  # noqa: E501
            raise ValueError("Invalid value for `smtp_host`, must not be `None`")  # noqa: E501

        self._smtp_host = smtp_host

    @property
    def smtp_port(self):
        """Gets the smtp_port of this CreateConnectorSmtpConnectionOptions.  # noqa: E501


        :return: The smtp_port of this CreateConnectorSmtpConnectionOptions.  # noqa: E501
        :rtype: int
        """
        return self._smtp_port

    @smtp_port.setter
    def smtp_port(self, smtp_port):
        """Sets the smtp_port of this CreateConnectorSmtpConnectionOptions.


        :param smtp_port: The smtp_port of this CreateConnectorSmtpConnectionOptions.  # noqa: E501
        :type: int
        """

        self._smtp_port = smtp_port

    @property
    def smtp_ssl(self):
        """Gets the smtp_ssl of this CreateConnectorSmtpConnectionOptions.  # noqa: E501


        :return: The smtp_ssl of this CreateConnectorSmtpConnectionOptions.  # noqa: E501
        :rtype: bool
        """
        return self._smtp_ssl

    @smtp_ssl.setter
    def smtp_ssl(self, smtp_ssl):
        """Sets the smtp_ssl of this CreateConnectorSmtpConnectionOptions.


        :param smtp_ssl: The smtp_ssl of this CreateConnectorSmtpConnectionOptions.  # noqa: E501
        :type: bool
        """

        self._smtp_ssl = smtp_ssl

    @property
    def smtp_username(self):
        """Gets the smtp_username of this CreateConnectorSmtpConnectionOptions.  # noqa: E501


        :return: The smtp_username of this CreateConnectorSmtpConnectionOptions.  # noqa: E501
        :rtype: str
        """
        return self._smtp_username

    @smtp_username.setter
    def smtp_username(self, smtp_username):
        """Sets the smtp_username of this CreateConnectorSmtpConnectionOptions.


        :param smtp_username: The smtp_username of this CreateConnectorSmtpConnectionOptions.  # noqa: E501
        :type: str
        """

        self._smtp_username = smtp_username

    @property
    def smtp_password(self):
        """Gets the smtp_password of this CreateConnectorSmtpConnectionOptions.  # noqa: E501


        :return: The smtp_password of this CreateConnectorSmtpConnectionOptions.  # noqa: E501
        :rtype: str
        """
        return self._smtp_password

    @smtp_password.setter
    def smtp_password(self, smtp_password):
        """Sets the smtp_password of this CreateConnectorSmtpConnectionOptions.


        :param smtp_password: The smtp_password of this CreateConnectorSmtpConnectionOptions.  # noqa: E501
        :type: str
        """

        self._smtp_password = smtp_password

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CreateConnectorSmtpConnectionOptions):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, CreateConnectorSmtpConnectionOptions):
            return True

        return self.to_dict() != other.to_dict()
